
DWORD _resbase;

void fix_rsrc(DWORD x)
{
// 00h  DWord  Flags
// 04h  DWord  Time/Date Stamp
// 08h  Word   Major Version
// 0Ah  Word   Minor Version
// 0Ch  Word   Name Entry
// 0Eh  Word   ID_Num Entry
//
  FLAG(x+0x00) |= FLAG_DD;
  FLAG(x+0x04) |= FLAG_DD;
  FLAG(x+0x08) |= FLAG_DW;
  FLAG(x+0x0A) |= FLAG_DW;
  FLAG(x+0x0C) |= FLAG_DW;
  FLAG(x+0x0E) |= FLAG_DW;
  DWORD c = MEMW(x+0x0C) + MEMW(x+0x0E);
  DWORD t = x + 0x10;
  while (c--)
  {
    DWORD w = _resbase + (MEMD(t+0x00) & 0x7FFFFFFF);
    if (MEMD(t+0x00) & 0x80000000)
    {
      FLAG(t+0x00) |= FLAG_RES | FLAG_RES8;
      FLAG( w ) |= FLAG_LABEL | FLAG_DREF;
    }
    else
      FLAG(t+0x00) |= FLAG_DD;
    DWORD q = _resbase + (MEMD(t+0x04) & 0x7FFFFFFF);
    FLAG(q) |= FLAG_LABEL + FLAG_DREF;
    if (MEMD(t+0x04) & 0x80000000)
    {
      FLAG(t+0x04) |= FLAG_RES | FLAG_RES8;
      fix_rsrc(q);
    }
    else
    {
      FLAG(t+0x04) |= FLAG_RES;
      FLAG( q+0x00 ) |= FLAG_RVA;
      FLAG( q+0x04 ) |= FLAG_DD;
      FLAG( q+0x08 ) |= FLAG_DD;
      FLAG( q+0x0C ) |= FLAG_DD;
      FLAG( pe->pe_imagebase + MEMD(q+0x00) ) |= FLAG_LABEL | FLAG_DREF;
    }
    t+=8;
  } //while

} // fix_rsrc

void load(char* fname)
{
  printf(" loading %s\n", fname);

  FILE*f = fopen(fname, "rb");
  assert(f);
  MZ_HEADER mz0;
  PE_HEADER pe0;
  fread(&mz0, 1,sizeof(mz0), f);
  assert(mz0.mz_id == 'MZ');
  fseek(f, mz0.mz_neptr, SEEK_SET);
  fread(&pe0, 1,sizeof(pe0), f);
  assert(pe0.pe_id == 'PE\x00\x00');
  fseek(f, 0, SEEK_SET);

/*
  if (pe0.pe_flags & 1)
  {
    printf("error: relocs required\n");
    exit(0);
  }
*/

  ALLOC(pe0.pe_imagebase, pe0.pe_imagesize);
  LOAD(pe0.pe_imagebase, pe0.pe_headersize, f,0);

  mz = (MZ_HEADER*) DATAPTR(pe0.pe_imagebase);
  pe = (PE_HEADER*) DATAPTR(pe0.pe_imagebase + mz0.mz_neptr);
  DWORD oe0 = pe0.pe_imagebase + mz0.mz_neptr + 0x18 + pe0.pe_ntheadersize;
  oe = (PE_OBJENTRY*) DATAPTR( oe0 );

#define align(x,y)      (((x)+(y)-1)&(~((y)-1)))
  for (int i = 0; i < pe0.pe_numofobjects; i++)
  {
    oe[i].oe_physsize = align(oe[i].oe_physsize, pe->pe_filealign);
    //
    if (oe[i].oe_virtsize == 0)
      oe[i].oe_virtsize = oe[i].oe_physsize;
    //
    oe[i].oe_virtsize = align(oe[i].oe_virtsize, pe->pe_objectalign);
  }

  for (int i = 0; i < pe0.pe_numofobjects; i++)
  {
//  printf("  %-8s .%08X %08X\n", oe[i].oe_name, oe[i].oe_virtrva, oe[i].oe_physoffs);
    LOAD(pe0.pe_imagebase + oe[i].oe_virtrva, oe[i].oe_physsize,
              f, oe[i].oe_physoffs);
    //
    FLAG( oe0+0x18 ) |= FLAG_DD;
    FLAG( oe0+0x1C ) |= FLAG_DD;
    FLAG( oe0+0x20 ) |= FLAG_DD;
    FLAG( oe0+0x24 ) |= FLAG_DD;
    oe0 += sizeof(PE_OBJENTRY);
    //
  }
  fclose(f);

  for (DWORD i=0; i<0x1C; i+=2)
    FLAG( pe0.pe_imagebase + i) |= FLAG_DW;
  FLAG( pe0.pe_imagebase + 0x3C) |= FLAG_DD;

  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x00) |= FLAG_DD;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x04) |= FLAG_DW;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x0C) |= FLAG_DD;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x10) |= FLAG_DD;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x14) |= FLAG_DW;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x16) |= FLAG_DW;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x18) |= FLAG_DW;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x1C) |= FLAG_DD;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x20) |= FLAG_DD;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x24) |= FLAG_DD;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x28) |= FLAG_DD|FLAG_RVA;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x2C) |= FLAG_DD;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x30) |= FLAG_DD;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x40) |= FLAG_DW;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x42) |= FLAG_DW;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x44) |= FLAG_DW;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x46) |= FLAG_DW;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x48) |= FLAG_DW;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x4A) |= FLAG_DW;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x4C) |= FLAG_DW;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x5C) |= FLAG_DW;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x5E) |= FLAG_DW;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x60) |= FLAG_DD;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x64) |= FLAG_DD;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x68) |= FLAG_DD;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x6C) |= FLAG_DD;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x70) |= FLAG_DD;
  FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x74) |= FLAG_DD;
  for (DWORD i=0; i<pe0.pe_numofrvaandsizes; i++)
  {
    FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x78+i*8+0) |= FLAG_DD|FLAG_RVA;
    FLAG(pe0.pe_imagebase+mz0.mz_neptr+0x78+i*8+4) |= FLAG_DD|FLAG_RVA;
  }

//printf("- marking entrypoint\n");

  FLAG( pe0.pe_imagebase+pe0.pe_entrypointrva ) |= FLAG_LABEL;

//printf("- marking imports\n");

  if (pe0.pe_importrva)
  {
//DWORD   im_lookup;              // 00
//DWORD   im_datetime;            // 04  ?
//DWORD   im_forward;             // 08  -1
//DWORD   im_name;                // 0C
//DWORD   im_addresstable;        // 10
    DWORD imp0 = pe0.pe_imagebase + pe0.pe_importrva;
    FLAG(imp0) |= FLAG_LABEL;
    PE_IMPORT *imp = (PE_IMPORT*)DATAPTR( imp0 );
    while ( imp->im_addresstable )
    {
      FLAG(imp0+0x00) |= FLAG_DD;
      FLAG(imp0+0x04) |= FLAG_DD;
      FLAG(imp0+0x08) |= FLAG_DD;
      if (imp->im_lookup != 0)
      {
        FLAG(imp0 + 0x00) |= FLAG_RVA;
        FLAG(pe0.pe_imagebase + MEMD(imp0 + 0x00)) |= FLAG_LABEL | FLAG_DREF;
        DWORD a = pe0.pe_imagebase + imp->im_lookup;
        while (MEMD(a) != 0)
        {
          if (MEMD(a) < pe0.pe_imagesize)
          {
            FLAG( pe0.pe_imagebase + MEMD(a) ) |= FLAG_LABEL | FLAG_DREF | FLAG_DW;
            FLAG( a ) |= FLAG_IMPORT | FLAG_RVA;
          }
          a += 4;
        }
      }
      FLAG(imp0 + 0x0C) |= FLAG_RVA;
      FLAG(imp0 + 0x10) |= FLAG_RVA;
      FLAG(pe0.pe_imagebase + MEMD(imp0 + 0x0C)) |= FLAG_LABEL | FLAG_DREF;
      FLAG(pe0.pe_imagebase + MEMD(imp0 + 0x10)) |= FLAG_LABEL | FLAG_DREF;
      DWORD a = pe0.pe_imagebase + imp->im_addresstable;
      while (MEMD(a) != 0)
      {
        if (MEMD(a) < pe0.pe_imagesize)
        {
          FLAG( pe0.pe_imagebase + MEMD(a) ) |= FLAG_LABEL | FLAG_DREF;
          FLAG( a ) |= FLAG_IMPORT | FLAG_RVA;
        }
        a += 4;
      }
      (DWORD)imp += sizeof(PE_IMPORT);
      imp0 += sizeof(PE_IMPORT);
    }
  }

  if (pe0.pe_iatrva)
  {
    for (DWORD i=pe0.pe_iatrva; i < pe0.pe_iatrva+pe0.pe_iatsize; i+=4)
      FLAG( pe0.pe_imagebase+i ) |= FLAG_DD;
  }

//printf("- marking exports\n");

  if (pe0.pe_exportrva)
  {
//DWORD   ex_flags;               // 00 01 02 03
//DWORD   ex_datetime;            // 04 05 06 07
//WORD    ex_major_ver;           // 08 09
//WORD    ex_minor_ver;           // 0A 0B
//DWORD   ex_namerva;             // 0C 0D 0E 0F
//DWORD   ex_ordinalbase;         // 10 11 12 13
//DWORD   ex_numoffunctions;      // 14 15 16 17
//DWORD   ex_numofnamepointers;   // 18 19 1A 1B
//DWORD   ex_addresstablerva;     // 1C 1D 1E 1F
//DWORD   ex_namepointersrva;     // 20 21 22 23
//DWORD   ex_ordinaltablerva;     // 24 25 26 27
    DWORD exp0 = pe0.pe_imagebase + pe0.pe_exportrva;
    FLAG(exp0+0x00) |= FLAG_DD;
    FLAG(exp0+0x04) |= FLAG_DD;
    FLAG(exp0+0x08) |= FLAG_DW;
    FLAG(exp0+0x0A) |= FLAG_DW;
    FLAG(exp0+0x0C) |= FLAG_RVA;
    FLAG(exp0+0x10) |= FLAG_DD;
    FLAG(exp0+0x14) |= FLAG_DD;
    FLAG(exp0+0x18) |= FLAG_DD;
    FLAG(exp0+0x1C) |= FLAG_RVA;
    FLAG(exp0+0x20) |= FLAG_RVA;
    FLAG(exp0+0x24) |= FLAG_RVA;
    FLAG(pe0.pe_imagebase + MEMD(exp0+0x0C)) |= FLAG_LABEL | FLAG_DREF;
    FLAG(pe0.pe_imagebase + MEMD(exp0+0x1C)) |= FLAG_LABEL | FLAG_DREF;
    FLAG(pe0.pe_imagebase + MEMD(exp0+0x20)) |= FLAG_LABEL | FLAG_DREF;
    FLAG(pe0.pe_imagebase + MEMD(exp0+0x24)) |= FLAG_LABEL | FLAG_DREF;
    PE_EXPORT *exp = (PE_EXPORT*)DATAPTR( exp0 );
    for (DWORD i = 0; i < exp->ex_numoffunctions; i++)
    {
      DWORD t = pe0.pe_imagebase + exp->ex_addresstablerva + i*4;
      FLAG( t ) |= FLAG_RVA;
      FLAG( pe0.pe_imagebase + MEMD( t ) ) |= FLAG_LABEL | FLAG_DREF | FLAG_EXPORT;
    }
    for (DWORD i = 0; i < exp->ex_numofnamepointers; i++)
    {
      DWORD t = pe0.pe_imagebase + exp->ex_namepointersrva + i*4;
      FLAG( t ) |= FLAG_RVA;
      FLAG( pe0.pe_imagebase + MEMD( t ) ) |= FLAG_LABEL | FLAG_DREF;
    }
  }

//printf("- marking fixups\n");

  if ((pe0.pe_fixuprva==0) || (pe0.pe_flags & 1))
  {
    printf("***WARNING***: File has no fixups. No chance for correct disasm.\n");
  }
  else
  {

    if (pe0.pe_flags & 0x2000)
    {
      printf("***WARNING***: File is DLL, and relocations will be stripped.\n");
    }

//DWORD   fx_pagerva;             // 00 01 02 03
//DWORD   fx_blocksize;           // 04 05 06 07
//WORD    fx_typeoffs[);          // 08 09 .. ..
    PE_FIXUP* fx = (PE_FIXUP*) DATAPTR( pe0.pe_imagebase + pe0.pe_fixuprva );
    DWORD t = 0;
    while (t < pe0.pe_fixupsize)
    {
      for (DWORD i = 0; i < (fx->fx_blocksize - 8) / 2; i++)
        if ((fx->fx_typeoffs[i] >> 12) == 3)
        {
          DWORD j = pe0.pe_imagebase + fx->fx_pagerva +
                    (fx->fx_typeoffs[i] & 0x0FFF);
          FLAG( j ) |= FLAG_FIXUP;
          FLAG( MEMD( j ) ) |= FLAG_LABEL | FLAG_DREF;
        }
      t += fx->fx_blocksize;
      (DWORD)fx += fx->fx_blocksize;
    }
  }

  // kill relocs

  for (DWORD
       i = pe->pe_imagebase + pe->pe_fixuprva;
       i < pe->pe_imagebase + pe->pe_fixuprva + pe->pe_fixupsize;
       i++)
    MEMB(i) = 0;
  pe->pe_fixuprva = 0;
  pe->pe_fixupsize = 0;
  pe->pe_flags |= 1;    // relocs stripped

//printf("- marking resources\n");

  if (pe0.pe_resourcerva)
  {
    _resbase = pe0.pe_imagebase+pe0.pe_resourcerva;
    fix_rsrc( _resbase );
  }

}
